#ifndef __AY_H
#define __AY_H

#include "z80.h"

#define	CAY_TOGGLEADDR	0xabcd

#define CULA_AUDIOEVENT_LENGTH	65536


class CAY: public CZ80IO
{
	public:
		CAY();
		~CAY();

		void Write(CZ80 &CPU, Uint16 Addr, Uint8 Value8, Uint64 Value64, Uint32 Time);
		void Read(CZ80 &CPU, Uint16 Addr, Uint8 &Value8, Uint64 &Value64, Uint32 Time);
		Uint32 Update(Uint32 cycles, bool);

	private:
		Uint8 Registers[16], CReg;

		static void AudioUpdateFunctionHelper(void *tptr, Uint8 *TargetBuffer, int TargetLength);
		void AudioUpdateFunction(void *tptr, Uint8 *TargetBuffer, int TargetLength);

		SDL_AudioSpec AudioSpec;
		struct AudioEvent
		{
			Uint8 Value, Register;
			Uint32 SampleDiff, ClockTime, Remainder;
		};

		struct Channel
		{
			Uint32 Pitch, ToneMask, NoiseMask;
			int Volume, *VolPtr;
			unsigned int SamplePos, SampleAdd;
		} Channels[3];
		Uint32 NoisePos, NoiseAdd;

		Sint32 EnvelopePos, EnvelopeAdd, EnvelopePitch, EnvelopeMask;
		int EnvelopeVolume;

		int *EnvelopePattern;
		int EnvelopePatterns[5][32];
		Uint16 NoiseWave[1024];

		void FixChannel(int);
		void FixEnvelope();

		AudioEvent AudioBuffer[CULA_AUDIOEVENT_LENGTH];
		Uint32 AudioWritePtr, AudioReadPtr;
		SDL_mutex *AudioReadPtrMutex;
		void WriteAudioEvent(Uint32);

		Uint32 AudioMask, AudioProcessTime, TotalTime, AudioNumerator;
		bool AudioEnabled;

		Sint16 SpeakerLevel;

		void EnactAudioEvent();
};

#endif