#ifndef __SCREEN_H
#define __SCREEN_H

class CZ80;
#include "sdl.h"

#define CSF_MULTIPLEXED		1
#define CSF_ALLOWOVERLAY	2

class CScreen
{
	public:
		void SetBorderCol(Uint8 Colour, Uint32 Time);
		Uint32 Update(Uint32 cycles, bool);

		CScreen();
		~CScreen();

		void Attach(CZ80 *);
		void ToggleFullscreen();

		void SetFlags(Uint32 Flags);
		Uint32 GetFlags();

		void SetMultiPalette(Uint8 *);
		const Uint8 *GetMultiPalette();

		bool HasScreen();
	private:
		Uint8 MultiPalette[129*256*3]; /* NOT a typo */

		SDL_Surface *front;
		SDL_Overlay *over;
		Uint8 PelData8[35454];
		Uint64 PelData64[35454];
		int CopySources[35454];

		Uint8	*Lookup;
		Uint8	*MultiLookup;

		Uint32 GFXFlags;
		Uint32 FrameNo, BehindNo;

		void SetupGraphics();
		struct BorderEvent
		{
			Uint8 Colour;
			Uint32 Time;
		} BorderQueue[1024];
		Uint32 Time, BWritePtr, BReadPtr;
		Uint8 BColour;

		bool Multi, AllowOverlay, FlagsDirty;
};

extern CScreen *SCR;

#endif