#ifndef __TAPE_H
#define __TAPE_H

#include "z80.h"
#include <stdio.h>

class CULA;

class CTape
{
	public:
		CTape(CULA *);
		~CTape();

		bool Open(char *name, unsigned int Timestamp);
		void Close();

		bool ReadBit(unsigned int Timestamp);

		static void TapeTrap(void *, CZ80 &, Uint16);
		void TapeTrap(CZ80 &, Uint16);
		void SetTrapFunction( void (* Trap)(void *, CZ80 &, Uint16 Addr, Uint16 Length), void *param = NULL);

	private:
		CULA *ULA;

		FILE *Tape;
		void (* TrapFunction)(void *, CZ80 &, Uint16 Addr, Uint16 Length);
		void *TrapParam;
};

#endif
